/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.messages;

import de.steamwar.sql.SteamwarUser;
import lombok.Getter;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.event.ClickEvent;

import java.util.Arrays;
import java.util.stream.Stream;

@Getter
public class ChatterGroup extends Chatter.PlayerlessChatter {

    final Chatter[] chatters;

    public ChatterGroup(Stream<Chatter> stream) {
        chatters = stream.toArray(Chatter[]::new);
    }

    public ChatterGroup(Chatter... chatters) {
        this.chatters = chatters;
    }

    @Override
    public boolean chatShown() {
        return Arrays.stream(chatters).allMatch(Chatter::chatShown);
    }

    @Override
    public void send(boolean prefixed, Message onHover, ClickEvent onClick, Message message) {
        for (Chatter sender : chatters) {
            sender.send(prefixed, onHover, onClick, message);
        }
    }

    @Override
    public SteamwarUser user() {
        throw new UnsupportedOperationException();
    }

    @Override
    public void sendMessage(Component msg) {
        throw new UnsupportedOperationException();
    }
}
